From 8b6ffa6ab1099704e09e5ca0d3755167527622c4 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 02:17:17 +0000
Subject: [PATCH 463/2232] Fix mutability of push_back trait method


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index be58cbd..c404e00 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -693,10 +693,10 @@ fn expand_cxx_vector(namespace: &Namespace, elem: &Ident) -> TokenStream {
                 }
                 &*__get_unchecked(v, pos)
             }
-            fn __push_back(v: &::cxx::CxxVector<Self>, item: &Self) {
+            fn __push_back(v: &mut ::cxx::CxxVector<Self>, item: &Self) {
                 extern "C" {
                     #[link_name = #link_push_back]
-                    fn __push_back(_: &::cxx::CxxVector<#elem>, _: &#elem);
+                    fn __push_back(_: &mut ::cxx::CxxVector<#elem>, _: &#elem);
                 }
                 unsafe { __push_back(v, item) }
             }
diff --git a/src/cxx_vector.rs b/src/cxx_vector.rs
index 8294044..77e7af1 100644
--- a/src/cxx_vector.rs
+++ b/src/cxx_vector.rs
@@ -126,7 +126,7 @@ pub unsafe trait VectorElement: Sized {
     const __NAME: &'static dyn Display;
     fn __vector_size(v: &CxxVector<Self>) -> usize;
     unsafe fn __get_unchecked(v: &CxxVector<Self>, pos: usize) -> &Self;
-    fn __push_back(v: &CxxVector<Self>, item: &Self);
+    fn __push_back(v: &mut CxxVector<Self>, item: &Self);
     fn __unique_ptr_null() -> *mut c_void;
     unsafe fn __unique_ptr_raw(raw: *mut CxxVector<Self>) -> *mut c_void;
     unsafe fn __unique_ptr_get(repr: *mut c_void) -> *const CxxVector<Self>;
@@ -158,11 +158,11 @@ macro_rules! impl_vector_element_for_primitive {
                 }
                 &*__get_unchecked(v, pos)
             }
-            fn __push_back(v: &CxxVector<$ty>, item: &$ty) {
+            fn __push_back(v: &mut CxxVector<$ty>, item: &$ty) {
                 extern "C" {
                     attr! {
                         #[link_name = concat!("cxxbridge02$std$vector$", stringify!($ty), "$push_back")]
-                        fn __push_back(_: &CxxVector<$ty>, _: &$ty);
+                        fn __push_back(_: &mut CxxVector<$ty>, _: &$ty);
                     }
                 }
                 unsafe { __push_back(v, item) }

